#!/usr/bin/env python
import sys
import os.path
import rosapi
import mysql.connector
import settings

def createDict(*args):
	return dict(((k, eval(k)) for k in args))

# check args
if len(sys.argv) < 2:
	sys.exit('Usage: {} <hostname>'.format(os.path.basename(sys.argv[0])))
hostname = sys.argv[1]

# obtain username and password
cnx = mysql.connector.connect(**settings.DBCONFIG)
cur = cnx.cursor()
cur.execute('SELECT username, password FROM devices WHERE hostname = %(hostname)s', createDict('hostname'))
row = cur.fetchone()
if row is None:
	sys.exit("Error: Host `{}' is not registered".format(hostname))
(username, password) = row

# obtain software-id
api = rosapi.RouterboardAPI(hostname, username, password)
r = api.get_resource('/system/license').call('print', {})[0]
if not 'software-id' in r:
	sys.exit("Error: Host `{}': can not obtain software-id".format(hostname))
software_id = r['software-id']
print 'software-id: {}'.format(software_id)

cur.execute('UPDATE devices SET software_id = %(software_id)s WHERE hostname = %(hostname)s',
	createDict('hostname', 'software_id'))
cnx.commit()
